local BaikActionbar = LibStub("AceAddon-3.0"):NewAddon("BaikActionbar", "AceConsole-3.0")
local DEBUG = false

local DEFAULTS = {
    profile = {
        bags = "Hover",
        hideGryphons = false,
        stance = "Show",
    }
}
local options = {
    name = "BaikActionbar",
    handler = BaikActionbar,
    type = "group",
    args = {}
}

---- BaikActionbar Functions ----
function BaikActionbar:DPrint(fmt, ...)
    if DEBUG then
        self:Print(string.format(fmt, ...))
    end
end

function BaikActionbar:Update()
    for _, module in pairs(self.modules) do
        module:OnUpdate()
    end
end

---- Ace Callbacks ----
function BaikActionbar:OnInitialize()
    self.db = LibStub("AceDB-3.0"):New("BaikActionbarDB", DEFAULTS, true)
    self.options = options
    self.options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
    self.options.args.profiles["order"] = -1
    self.modules = {
        self:GetModule("MainBar"),
        self:GetModule("Bags"),
        self:GetModule("StanceBar")
    }
    self:DPrint("OnInitialize")
end

function BaikActionbar:OnEnable()
    LibStub("AceConfig-3.0"):RegisterOptionsTable("BaikActionbar", self.options)
    LibStub("AceConfigDialog-3.0"):AddToBlizOptions("BaikActionbar", "BaikActionbar")
    self:DPrint("OnEnable")
end

function BaikActionbar:OnDisable()
end
